<template>
  <div>

    <h2>Edytuj przegląd:</h2>

    <br/>
    <hr>

    <form
        v-on:submit.prevent="submitForm"
    >

      <div class="form-group">
        <label for="inspectionDate">Nowa data przeglądu:</label>
        <vue-englishdatepicker id="inspectionDate" v-model="form.inspectionDate"/>
        <br/>
        Aktualna data przeglądu to <strong>{{ oldInspection.inspectionDate }}</strong>
      </div>

      <hr>

      <div class="form-group">
        <label for="notes">Nowe notatki:</label>
        <input type="text"
               class="form-control"
               id="notes"
               placeholder="Notatki"
               maxlength="255"
               v-model="form.notes"
        >
        <br/>
        Aktualny wpis: <strong>{{ oldInspection.notes }}</strong>
      </div>

      <hr>

      <div class="form-group">
        <label for="feeding">Był podkarmiany?</label>
        <input type="checkbox"
               id="feeding"
               :checked="oldInspection.feeding === true"
               v-on:input="form.feeding = $event.target.checked; flagFeeding = true"
        >
      </div>

      <div class="form-group">
        <label for="queen">Była matka?</label>
        <input type="checkbox"
               id="queen"
               :checked="oldInspection.queen === true"
               v-on:input="form.queen = $event.target.checked; flagQueen = true"
        >
      </div>

      <div class="form-group">
        <label for="treatment">Był leczony?</label>
        <input type="checkbox"
               id="treatment"
               :checked="oldInspection.treatment === true"
               v-on:input="form.treatment = $event.target.checked; flagTreatment = true"
        >
      </div>

      <div class="form-group">
        <button class="btn btn-primary">Edytuj</button>
      </div>
    </form>
  </div>

</template>

<script>
import InspectionService from '../../services/inspection.service';
import VueEnglishdatepicker from 'vue-englishdatepicker';

import 'vue-slider-component/theme/antd.css'
import inspectionobject from "@/models/inspectionobject";

export default {
  name: 'EditInspection',
  components: {
    VueEnglishdatepicker,
  },
  data() {
    return {
      content: '',
      form: new inspectionobject('', false, false, false, '', ''),
      wasSubmitted: false,
      oldInspection: '',
      flagTreatment: false, flagQueen: false, flagFeeding: false
    };
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

    if (!this.currentUser) {
      this.$router.push('/login');
    } else if (this.$route.query.beehiveId && this.$route.query.inspectionId) {
      InspectionService.getSpecificInspectionById(this.$route.query.inspectionId).then(
          response => {
            this.oldInspection = response.data;
          },
          error => {
            this.oldInspection =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }

  },
  methods: {
    submitForm() {

      if (!this.currentUser) {
        this.$router.push('/login');
      } else {

        if (!this.currentUser) {
          this.$router.push('/login');
        } else if (this.$route.query.beehiveId && this.$route.query.inspectionId) {

          this.putOldData()

          this.form.beehiveId = this.$route.query.beehiveId

          InspectionService.editInspection(this.form, this.$route.query.inspectionId).then(
              response => {
                this.content = response.data;

                alert('Przegląd edytowany poprawnie!')

                this.$router.push('/beehive?beehiveid=' + this.$route.query.beehiveId)

              },
              error => {
                this.content =
                    (error.response && error.response.data && error.response.data.message) ||
                    error.message ||
                    error.toString();
              }
          );
        }
      }
    },

    putOldData() {
      if (!this.flagFeeding)
        this.form.feeding = this.oldInspection.feeding;

      if (!this.flagQueen)
        this.form.queen = this.oldInspection.queen;

      if (!this.flagTreatment)
        this.form.treatment = this.oldInspection.treatment;

      if (!this.form.inspectionDate)
        this.form.inspectionDate = this.oldInspection.inspectionDate;

      if (!this.form.notes)
        this.form.notes = this.oldInspection.notes;
    }
  }
};
</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}
</style>